Procodile = LibStub("AceAddon-3.0"):NewAddon("Procodile", "AceConsole-3.0", "AceEvent-3.0", "AceTimer-3.0", "LibBars-1.0", "LibSink-2.0", "LibMMButton-1.0")
local L = LibStub("AceLocale-3.0"):GetLocale("Procodile", false)
local bars = LibStub("LibBars-1.0")
local media = LibStub("LibSharedMedia-3.0")

BINDING_HEADER_Procodile = "Procodile"
BINDING_NAME_TOGGLE_PROCODILE = "Toggle"

local defaults = {
        profile = {
                combat = true,
                showspells = false,
                verbose = false,
                cooldowns = true,
                movablecooldowns = true,
                announce = true,
                barfontsize=9,
                barwidth=130,
                barheight=12,
                barfont=nil,
                bartexture="Aluminium",
                reversecooldowns=false,
                mmbutton=true,
                sinkOptions = {
                	sink20OutputSink = "Default",
				},
                -- internal
                enabled = false,
				tracked = {},
				dormant = {},
        }
}

local changed = true
local cooldowns
local mmbutton

-- options
local options = {
        type="group",
		name="Procodile",
        childGroups="tab",
        args={
        		d = {
        			type="description",
					name=L["PROCODILE_DESC"],
        		},
        		bars = {
	        			type="group",
                        name=L["BARS_NAME"],
                        args = {
                        	info = {
                        		type="description",
		                        name=L["BARS_DESC"],
		                        order=0,
                        	},
                                cooldowns = {
                                        type="toggle",
                                        name=L["COOLDOWNS_NAME"],
                                        desc=L["COOLDOWNS_DESC"],
                                        order=1,
                                        get=function() return Procodile.db.profile.cooldowns end,
                                        set=function() 
                                        		Procodile.db.profile.cooldowns = not Procodile.db.profile.cooldowns
                                        		if Procodile.db.profile.cooldowns then
                                        			Procodile:ShowCooldowns(true)
                                        		else
                                        			Procodile:ShowCooldowns(false)
                                        		end
                                        	end,
                                },
                                movablecooldowns = {
                                        type="toggle",
                                        name=L["MOVABLECOOLDOWNS_NAME"],
                                        desc=L["MOVABLECOOLDOWNS_DESC"],
                                        order=2,
                                        get=function() return Procodile.db.profile.movablecooldowns end,
                                        set=function() 
                                        		Procodile.db.profile.movablecooldowns = not Procodile.db.profile.movablecooldowns
                                        		Procodile:SetMovableCooldowns(Procodile.db.profile.movablecooldowns)
                                        	end,
                                },
                                announce = {
                                        type="toggle",
                                        name=L["ANNOUNCE_NAME"],
                                        desc=L["ANNOUNCE_DESC"],
                                        order=3,
                                        get=function() return Procodile.db.profile.announce end,
                                        set=function() Procodile.db.profile.announce = not Procodile.db.profile.announce end,
                                },
                        		bartexture = {
                        			type="select",
                        			name=L["BARTEXTURE_NAME"],
                        			desc=L["BARTEXTURE_DESC"],
                        			order=4,
                        			values=media:List('statusbar'),
                        			get=function(i)
                       						for k, v in pairs(media:List('statusbar')) do
												if v == Procodile.db.profile.bartexture then
													return k
												end
											end
                        				end,
                        			set=function(i, v)
                        					Procodile.db.profile.bartexture = media:List('statusbar')[v]
                        					Procodile:ReconfigureBars()
										end,
                        		}, 
                        		barfont = {
                        			type="select",
                        			name=L["BARFONT_NAME"],
                        			desc=L["BARFONT_DESC"],
                        			order=5,
                        			values=media:List('font'),
                        			get=function()
                       						for k, v in pairs(media:List('font')) do
												if v == Procodile.db.profile.barfont then
													return k
												end
											end
                        				end,
                        			set=function(k, v)
                        					Procodile.db.profile.barfont = media:List('font')[v]
                        					Procodile:ReconfigureBars()
										end,
                        		},                        		
                        		fontsize = {
                        			type="range",
                        			name=L["FONTSIZE_NAME"],
                        			desc=L["FONTSIZE_DESC"],
                        			min=6,
                        			max=20,
                        			step=1,
                        			order=5,
                        			get=function() return Procodile.db.profile.barfontsize end,
                        			set=function(key, size)
                        					Procodile.db.profile.barfontsize = size
                        					Procodile:ReconfigureBars()
										end,
                        		},
                        		barwidth = {
                        			type="range",
                        			name=L["BARWIDTH_NAME"],
                        			desc=L["BARWIDTH_DESC"],
                        			min=40,
                        			max=300,
                        			step=1,
                        			order=10,
                        			get=function() return Procodile.db.profile.barwidth end,
                        			set=function(key, size)
                        					Procodile.db.profile.barwidth = size
                        					Procodile:ReconfigureBars()
										end,
                        		},
                        		barheight = {
                        			type="range",
                        			name=L["BARHEIGHT_NAME"],
                        			desc=L["BARHEIGHT_DESC"],
                        			min=8,
                        			max=60,
                        			step=1,
                        			order=11,
                        			get=function() return Procodile.db.profile.barheight end,
                        			set=function(key, size)
                        					Procodile.db.profile.barheight = size
											Procodile:ReconfigureBars()
                        				end,
                        		},
                                reversebars = {
                                        type="toggle",
                                        name=L["REVERSECOOLDOWNS_NAME"],
                                        desc=L["REVERSECOOLDOWNS_DESC"],
                                        order=9,
                                        get=function() return Procodile.db.profile.reversecooldowns end,
                                        set=function() 
                                        		Procodile.db.profile.reversecooldowns = not Procodile.db.profile.reversecooldowns
                                       			Procodile:ReverseCooldowns(Procodile.db.profile.reversecooldowns)
                                        	end,
                                },
                                bartest = {
                        			type="execute",
                        			order=-1,
                        			name=L["BARTEST_NAME"],
                        			desc=L["BARTEST_DESC"],
                        			func=function() Procodile:TestBars() end,
                        		}
                        }
        		},
        		custom = {
        			type="group",
        			name=L["CUSTOM_NAME"],
        			args= {
        				info = {
        					type="description",
        					name=L["CUSTOM_DESC"],
        					order=0,
        				},
        				newcustom = {
        					type="input",
        					name=L["NEWCUSTOM_NAME"],
        					desc=L["NEWCUSTOM_DESC"],
        					order=1,
        					set=function(info, val) 
									local name, rank, icon, cost, isFunnel, powerType, castTime, minRange, maxRange = GetSpellInfo(val)
	        						if name then
	        							Procodile:AddSpell(tonumber(val), name, icon, true)
	        						end
        						end,
        				},
        				removecustom = {
        					type="select",
        					name=L["REMOVECUSTOM_NAME"],
        					desc=L["REMOVECUSTOM_DESC"],
        					order=2,
        					values=function()
        								local customs = {}
        								for index,spell in pairs(Procodile.db.profile.tracked) do
        									if spell.custom ~= nil then
        										customs[spell.id] = spell.name
        									end
        								end
        								return customs
        							end,
        					set=function(i, v)
       								for index,spell in pairs(Procodile.db.profile.tracked) do
       									if spell.id == v then
       										table.remove(Procodile.db.profile.tracked, index)
       										break;
       									end
       								end
        						end,
        				}
        			}	
        		},
                options = {
                       type="group",
                       name=L["OPTIONS_NAME"],
                       args = {
	                     	info = {
	                      		type="description",
		                        name=L["OPTIONS_DESC"],
		                        order=0,
	                      	},
							combat = {
							        type="toggle",
							        name=L["COMBATONLY_NAME"],
							        desc=L["COMBATONLY_DESC"],
							        order=1,
							        get=function() return Procodile.db.profile.combat end,
							        set=function() Procodile.db.profile.combat = not Procodile.db.profile.combat end,
							},
							showspells = {
							        type="toggle",
							        name=L["SHOWSPELLS_NAME"],
							        desc=L["SHOWSPELLS_DESC"],
							        order=2,
							        get=function() return Procodile.db.profile.showspells end,
							        set=function() Procodile.db.profile.showspells = not Procodile.db.profile.showspells end,
							},
							verbose = {
							        type="toggle",
							        name=L["VERBOSE_NAME"],
							        desc=L["VERBOSE_DESC"],
							        order=3,
							        get=function() return Procodile.db.profile.verbose end,
							        set=function() Procodile.db.profile.verbose = not Procodile.db.profile.verbose end,
							},
							mmbutton = {
							        type="toggle",
							        name=L["MINIMAP_NAME"],
							        desc=L["MINIMAP_DESC"],
							        order=4,
							        get=function() return Procodile.db.profile.mmbutton end,
							        set=function() 
							        		Procodile.db.profile.mmbutton = not Procodile.db.profile.mmbutton
											if Procodile.db.profile.mmbutton then
												Procodile:ShowMMButton()
											else
												Procodile:HideMMButton()
											end
							        	end,
							},
                       }
                },
                                
        },
}

function Procodile:OnInitialize()
	self:RegisterChatCommand("procodile", "Command")
	self:RegisterChatCommand("proc", "Command")
	self:RegisterChatCommand("proctest", "test")
	self:RegisterChatCommand("procscan", "ScanForProcs")
	
	self.db = LibStub("AceDB-3.0"):New("ProcodileDB", defaults)
	
	options.args.output = Procodile:GetSinkAce3OptionsDataTable()
	options.args.output.disabled = false
	self:SetSinkStorage(self.db.profile.sinkOptions)
	
	LibStub("AceConfig-3.0"):RegisterOptionsTable("Procodile", options)
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("Procodile", "Procodile")
	
	LibStub("AceConfig-3.0"):RegisterOptionsTable("Procodile-Profiles", LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db))
	self.profilesFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("Procodile-Profiles", "Profiles", "Procodile")

	self:SetupBars()

	-- Minimap button
	self:CreateMMButton()
	self:SetMMButtonIcon("Interface\\Icons\\Spell_Holy_WordFortitude")
	if self.db.profile.mmbutton then
		self:ShowMMButton()
	else
		self:HideMMButton()
	end
end

function Procodile:Command(input)
	for k,v in pairs(self.options.args.output) do
		self:Print(k)
		self:Print(v)
	end

	self:OpenOptions()
end

function Procodile:OpenOptions()
	InterfaceOptionsFrame_OpenToCategory("Procodile")
end

function Procodile:OnEnable()
	self:RegisterEvent("PLAYER_REGEN_DISABLED")
	self:RegisterEvent("PLAYER_REGEN_ENABLED")
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	self:RegisterEvent("UNIT_INVENTORY_CHANGED")
	changed = true
	
	-- Clean up tracked spells
	for internalname,proc in pairs(self.db.profile.tracked) do
		proc.laststarted = 0
		proc.started = 0
	end
	
	-- Check for item procs
	self:ScanForProcs()
	
	-- Should we enable tracking straight away?
	if self.db.profile.combat and InCombatLockdown() == nil then
		self:Toggle(false)
	else
		self:Toggle(true)
	end
	
	self:ScheduleRepeatingTimer("Tick", 1, nil)
	
end

function Procodile:OnDisable()
	self:CancelAllTimers()
	self.db.profile.enabled = false
	Procodile:Toggle(false)
end

function Procodile:ScanForProcs()
	-- Mark all tracked spells as not found after this inventory change
	for index, spell in ipairs(self.db.profile.tracked) do
		spell.found = false
		
		-- Custom spells should never be automatically removed 
		if spell.custom ~= nil then
			spell.found = true
		end
	end
	
	-- Talents
	local myclass = select(2, UnitClass("player"))
	for spell_id,theclass in pairs(self.talents) do
		if theclass == myclass then
			
			-- See if we are already tracking this item
			local exists = false
			for index, spell in pairs(self.db.profile.tracked) do
				if spell.id == spell_id then
					exists = true
					spell.found = true
				end
			end
			
			-- No, add it
			if not exists then
				local name, rank, icon, cost, isFunnel, powerType, castTime, minRange, maxRange = GetSpellInfo(spell_id)
				self:AddSpell(spell_id, name, icon)
			end
		end
	end

	-- For each inventory slot (ugly, should refer by IDs given by GetInventorySlotInfo()).
	for slotid = 1, 20 do
	
		local itemlink = GetInventoryItemLink("player", slotid)
		if itemlink ~= nil then
		
			-- Thank you, wowwiki
			local found, _, itemstring = string.find(itemlink, "^|c%x+|H(.+)|h%[.+%]")
			local _, itemId, enchantId, jewelId1, jewelId2, jewelId3, jewelId4, suffixId, uniqueId = strsplit(":", itemstring)
			local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture = GetItemInfo(itemlink)
			
			-- Item enchants
			if tonumber(enchantId) ~= 0 then
			
				for spell_id,spell_enchantid in pairs(self.enchants) do
					if spell_enchantid == tonumber(enchantId) then
						
						-- See if we are already tracking this item
						local exists = false
						for index, spell in pairs(self.db.profile.tracked) do
							if spell.id == spell_id then
								exists = true
								spell.found = true
							end
						end
						
						-- No, add it
						if not exists then
							self:AddSpell(spell_id, itemName, itemTexture)
						end
						
						break
					end
				end
				
			end

			-- Item proc spells
			for spell_id,spell_itemid in pairs(self.items) do
				if spell_itemid == tonumber(itemId) then
					
					-- See if we are already tracking this item
					local exists = false
					for index, spell in pairs(self.db.profile.tracked) do
						if spell.id == spell_id then
							exists = true
							spell.found = true
						end
					end
					
					-- No, add it
					if not exists then
						self:AddSpell(spell_id, itemName, itemTexture)
					end
					
					break
				end
			end
		end
		
	end
	
	-- Remove spells not found (item removed from inventory)
	for index, spell in pairs(self.db.profile.tracked) do
		if not spell.found then
			self:RemoveSpell(spell.id)
		end
	end
		
end

function Procodile:ShowCooldowns(show)
	if show then
		self.cooldowns:Show()
	else
		self.cooldowns:Hide()
	end
end

function Procodile:ReverseCooldowns(reverse)
	self.cooldowns:ReverseGrowth(reverse)
end

-- Returns all currently tracked spells
function Procodile:GetTrackedSpells()
	return self.db.profile.tracked
end

-- Adds a spell to the tracked spells
function Procodile:AddSpell(spellid, itemname, itemicon, iscustom)
	-- Attempt to find the spell in dormant
	local found = false
	for index, spell in pairs(self.db.profile.dormant) do
		if spell.id == spellid then
			found = true
			
			spell.started = 0
			spell.laststarted = 0
			spell.found = true
			table.insert(self.db.profile.tracked, spell)
			table.remove(self.db.profile.dormant, index)
			break
		end
	end
	
	if not found then
		-- Spell not found in dormant - create new
		local spell = {
					id = spellid, 
					name = itemname, 
					icon = itemicon, 
					seconds = 0, 
					count = 0, 
					started = 0, 
					totaltime = 0, 
					cooldown = 0, 
					laststarted = 0,
					found = true,
					custom = iscustom,
				}
		table.insert(self.db.profile.tracked, spell)
	end
	
	if self.db.profile.verbose then
		self:Print("adding "..itemname)
	end
end

function Procodile:RemoveSpell(spellid)
	for index, spell in pairs(self.db.profile.tracked) do
		if spell.id == spellid then
			-- Add to dormant
			table.insert(self.db.profile.dormant, spell)
			
			-- Remove from tracked
			table.remove(self.db.profile.tracked, index)
			
			self.cooldowns:RemoveBar(spell.name)
			
			if self.db.profile.verbose then
				self:Print("removing "..spell.name)
			end
			return
		end
	end
end

function Procodile:Reset()
	totaltime = 0
	for key,proc in pairs(self.db.profile.tracked) do
		proc.count = 0
		proc.seconds = 0
		proc.started = 0
		proc.totaltime = 0
		proc.laststarted = 0
		proc.cooldown = 0
	end
	
	self.db.profile.dormant = {}
	
	self:Print("|cff22ff22".."Data for all tracked procs has been reset")
	
	ProcodileFu:OnUpdateFuBarText()
end

function Procodile:ReconfigureBars()
	self.cooldowns:SetFont(media:Fetch('font', self.db.profile.barfont), self.db.profile.barfontsize)
	self.cooldowns:SetWidth(self.db.profile.barwidth)
	self.cooldowns:SetHeight(self.db.profile.barheight)
	self.cooldowns:SetTexture(media:Fetch('statusbar', self.db.profile.bartexture))
end

function Procodile:SetupBars()
	-- Create bar group
	self.cooldowns = self:NewBarGroup("Cooldowns", nil, self.db.profile.barwidth, self.db.profile.barheight, "ProcodileCooldowns")
	self.cooldowns:SetFont(media:Fetch('font', self.db.profile.barfont), self.db.profile.barfontsize)
	self.cooldowns:SetTexture(media:Fetch('statusbar', self.db.profile.bartexture))
	self.cooldowns:SetColorAt(1.00, 1.0, 0.2, 0.2, 0.8)
	self.cooldowns:SetColorAt(0.66, 1.0, 0.3, 0.3, 0.8)
	self.cooldowns:SetColorAt(0.33, 1.0, 0.4, 0.4, 0.8)
	self.cooldowns:SetColorAt(0.00, 1.0, 0.5, 0.5, 0.8)
	self.cooldowns.RegisterCallback(self, "AnchorClicked")
	self.cooldowns.RegisterCallback(self,"TimerFinished")
	self.cooldowns:SetUserPlaced(true)
	
	self.cooldowns:ReverseGrowth(self.db.profile.reversecooldowns or false)
	
	-- Cheat for getting anchor to work straight off; not sure why it doesn't until first bar is added.
	local bar = self.cooldowns:NewTimerBar("Test bar", "Test bar", 10, 10, "Interface\\Icons\\Spell_Holy_WordFortitude")
	bar:SetHeight(self.db.profile.barheight)
	bar:SetTimer(0, 0)
	
	if self.db.profile.cooldowns then
		self.cooldowns:Show()
	else
		self.cooldowns:Hide()
	end
	
	if self.db.profile.movablecooldowns then
		self.cooldowns:ShowAnchor()
	else
		self.cooldowns:HideAnchor()
	end
end

function Procodile:TimerFinished(evt, group, bar)
	if self.db.profile.announce then
		self:Pour(bar.name.." CD expired!", 1.0, 0.5, 0.5)
	end
end

function Procodile:AnchorClicked(cbk, group, button)
	if button == "RightButton" then
		self:SetMovableCooldowns(false)
	end
end

function Procodile:SetMovableCooldowns(movable)
	self.db.profile.movablecooldowns = movable
	if movable then
		self.cooldowns:ShowAnchor()
	else
		self.cooldowns:HideAnchor()
	end
end

function Procodile:Tick()
	if self.db.profile.enabled then
		for key,proc in pairs(self.db.profile.tracked) do
			if proc.started > 0 then
				proc.seconds = proc.seconds + 1
			end
			proc.totaltime = proc.totaltime + 1
		end
	end
end

function Procodile:TestBars()
	local bar = self.cooldowns:NewTimerBar("Test bar", "Test bar", 10, 10, "Interface\\Icons\\Spell_Holy_WordFortitude")
	bar:SetHeight(self.db.profile.barheight)
	bar:SetTimer(10, 10)
end

function Procodile:test()
	for key,proc in pairs(self.db.profile.tracked) do
		self:Print("key="..key)
		
		self:Print("id="..proc.id)
		self:Print("count="..proc.count)
		self:Print("seconds="..proc.seconds)
		self:Print("started="..proc.started)
	end
end

function Procodile:PLAYER_REGEN_ENABLED()
	-- Disable if we are enabled and are set to only track in combat
	if self.db.profile.enabled and self.db.profile.combat then
		Procodile:Toggle(false)
	end
end

function Procodile:PLAYER_REGEN_DISABLED()
	-- Enable if we are not enabled and are set to only track in combat
	if not self.db.profile.enabled and self.db.profile.combat then
		Procodile:Toggle(true)
	end
end

function Procodile:UNIT_INVENTORY_CHANGED(event, unit)
	if unit == "player" then
		self:ScanForProcs()
	end
end

function Procodile:HandleProc(proc, is_aura)
	if proc.laststarted > 0 and (proc.cooldown == 0 or (time() - proc.laststarted < proc.cooldown)) then
		proc.cooldown = time() - proc.laststarted
	
		if self.db.profile.announce and proc.cooldown < 300 then
			self:Pour(proc.name.." new cooldown detected: "..proc.cooldown.."s", 1.0, 0.5, 0.5)
		end
	end
	
	if is_aura then
		proc.started = time()
	end
	proc.count = proc.count + 1
	proc.laststarted = time()
	if self.db.profile.verbose then
		self:Print("|cff22ff22"..proc.name.." effect")
	end
	
	-- Reset cooldown bar
	if self.db.profile.cooldowns and proc.cooldown > 0 then
		local bar = self.cooldowns:GetBar(proc.name)
		if not bar then
			bar = self.cooldowns:NewTimerBar(proc.name, proc.name, proc.cooldown, proc.cooldown, proc.icon)
		end
		bar:SetHeight(self.db.profile.barheight)
		bar:SetTimer(proc.cooldown, proc.cooldown)
	end
	

end

function Procodile:COMBAT_LOG_EVENT_UNFILTERED(event, timestamp, eventtype, srcGUID, srcName, srcFlags, dstGUID, dstName, dstFlags, ...)
      	local obj = select(1, ...)
      	local match = false
      	
       if self.db.profile.enabled then

	        if dstName and ((srcName ~= nil and UnitIsUnit(srcName,"player")) or (dstName ~= nil and UnitIsUnit(dstName,"player"))) then

				-- Instant dmg by you on target
				if eventtype == 'SPELL_DAMAGE' and srcName ~= nil and UnitIsUnit(srcName,"player") then
--12/2 19:44:04.312  SPELL_DAMAGE,0x00000000004518D2,"Zo",0x512,0xF13000402D0060F6,"Soul Weaver",0x100a48,60488,"Extract of Necromatic Power",0x20,2065,0,32,0,0,0,1,nil,nil
--12/2 19:50:46.765  SPELL_DAMAGE,0x0000000000426DC0,"Ladybah",0x512,0xF13000402B006472,"Soldier of the Frozen Wastes",0xa48,55637,"Lightweave Bolt",0x2,1955,293,2,0,0,0,1,nil,nil

		        	for internalname,proc in pairs(self.db.profile.tracked) do
		        		if proc.id == obj then
		        			match = true
		        		
		        			self:HandleProc(proc, false)
			        		
			        		changed = true
		        		end
		        	end

		        	if not match and self.db.profile.showspells then
				       	local spellname = select(2, ...)
			        	self:Print("Spell "..spellname.." ("..obj..") hit enemy.")
		        	end					

				end

				-- Instant energize on self
				if eventtype == 'SPELL_ENERGIZE' and ((srcName ~= nil and UnitIsUnit(srcName,"player")) or (dstName ~= nil and UnitIsUnit(dstName,"player"))) then
--12/2 19:43:19.578  SPELL_ENERGIZE,0x000000000035F51C,"Dimqroy",0x514,0x000000000035F51C,"Dimqroy",0x514,60538,"Soul of the Dead",0x40,900,0
		        	for internalname,proc in pairs(self.db.profile.tracked) do
		        		if proc.id == obj then
		        			match = true
		        			
		        			self:HandleProc(proc, false)
			        		
			        		changed = true
		        		end
		        	end

		        	if not match and self.db.profile.showspells then
				       	local spellname = select(2, ...)
			        	self:Print("Spell "..spellname.." ("..obj..") energized.")
		        	end					
				end
	
	        	-- Aura applied on self/target
		        if eventtype == 'SPELL_AURA_APPLIED' and ((srcName ~= nil and UnitIsUnit(srcName,"player")) or (dstName ~= nil and UnitIsUnit(dstName,"player"))) then
		        	for internalname,proc in pairs(self.db.profile.tracked) do
		        		if proc.id == obj then
		        			match = true
		        		
							self:HandleProc(proc, true)
			        		
			        		changed = true
		        		end
		        	end

		        	if not match and self.db.profile.showspells then
				       	local spellname = select(2, ...)
			        	self:Print("Spell "..spellname.." ("..obj..") applied.")
		        	end
		        end
		
		        -- Aura removed on self/target
		        if eventtype == 'SPELL_AURA_REMOVED' and ((srcName ~= nil and UnitIsUnit(srcName,"player")) or (dstName ~= nil and UnitIsUnit(dstName,"player"))) then
		        	for internalname,proc in pairs(self.db.profile.tracked) do
		        		if proc.id == obj then
		        			match = true
		        		
			        		proc.started = 0
			        		if self.db.profile.verbose then
				        		self:Print("|cff22ff22"..proc.name.." effect ended")
			        		end
			        		
			        		changed = true
		        		end
		        	end
		        	
		        	if not match and self.db.profile.showspells then
				       	local spellname = select(2, ...)
			        	self:Print("Spell "..spellname.." ("..obj..") removed.")
		        	end
		        end
				
--	        	self:Print("|cff22ff22"..eventtype..', srcGUID='..srcGUID..', dstGUID='..dstGUID..', obj='..obj)
	        end
       	
       end
end


function Procodile:IsEnabled()
	return self.db.profile.enabled
end

function Procodile:Toggle(enabled)
	if enabled ~= nil then
		self.db.profile.enabled = enabled
	else
        self.db.profile.enabled = not self.db.profile.enabled
	end

	if self.db.profile.verbose then
		if self.db.profile.enabled then
			self:Print("|cff22ff22"..L["TOGGLE_ENABLED"])
		else
			self:Print("|cffff2222"..L["TOGGLE_DISABLED"])
		end
	end
	
	-- Reset some variables we only track while enabled
	if not self.db.profile.enabled then
       	for internalname,proc in pairs(self.db.profile.tracked) do
       		proc.laststarted = 0
       		proc.started = 0
       	end
	end
	
	ProcodileLDB:UpdateText(self.db.profile.enabled)
end

function Procodile:PopulateTooltip()

    GameTooltip:AddLine(L["Procodile"])
    GameTooltip:AddLine(" ")
    
    local tracked = Procodile:GetTrackedSpells()
    
	for internalname,proc in pairs(tracked) do
		-- PPM
		local ppm = 0
		if proc.count > 0 then
			ppm = proc.count / (proc.totaltime / 60)
		end
		
		-- Uptime
		local uptime = 0
		if proc.seconds > 0 and proc.totaltime > 0 then
			uptime = proc.seconds / proc.totaltime * 100
		end
				
		GameTooltip:AddLine(proc.name, 0.3, 0.3, 0.8)
		GameTooltip:AddTexture(proc.icon)
		if proc.count > 0 then
		    GameTooltip:AddDoubleLine(L["Procs"], proc.count, nil, nil, nil, 1,1,1)
		else
		    GameTooltip:AddDoubleLine(L["Procs"], "none", nil, nil, nil, 1,1,1)
		end
			
	    if ppm > 0 then
		    GameTooltip:AddDoubleLine(L["PPM"], string.format("%.2f", ppm), nil, nil, nil, 1,1,1)
		else
		    GameTooltip:AddDoubleLine(L["PPM"],"unknown", nil, nil, nil, 1,1,1)
		end
		
		if uptime > 0 then
		    GameTooltip:AddDoubleLine(L["Uptime"], string.format("%.2f", uptime).."%", nil, nil, nil, 1,1,1)
		else
		    GameTooltip:AddDoubleLine(L["Uptime"], "unknown", nil, nil, nil, 1,1,1)
		end
		
	    if proc.cooldown > 0 then
		    GameTooltip:AddDoubleLine(L["Cooldown"], proc.cooldown.."s", nil, nil, nil, 1,1,1)
		else
		    GameTooltip:AddDoubleLine(L["Cooldown"], "unknown", nil, nil, nil, 1,1,1)
		end
		GameTooltip:AddLine(" ")
	end
end


function Procodile:OnMMButtonClick(button)
	self:OpenOptions()
end

function Procodile:LibMMButtonOnEnter()
    GameTooltip:SetOwner(self.LibMMButtonFrame, "ANCHOR_NONE")
    GameTooltip:SetPoint("TOPLEFT", self.LibMMButtonFrame, "BOTTOMLEFT")
    GameTooltip:ClearLines()
    
    Procodile.PopulateTooltip()
    
    GameTooltip:AddLine(L["Left-Click to configure."], 0, 1, 0)
    GameTooltip:AddLine(L["Right-click and drag to move."], 0, 1, 0)

    GameTooltip:Show()
end