local Procodile = LibStub("AceAddon-3.0"):GetAddon("Procodile")
local L = LibStub("AceLocale-3.0"):GetLocale("Procodile", false)

ProcodileLDB = Procodile:NewModule("ProcodileLDB")

local ldb = LibStub:GetLibrary("LibDataBroker-1.1")

local dataobj = ldb:NewDataObject("Procodile", {type = "data source", icon = "Interface\\Icons\\Spell_Holy_WordFortitude", text = ""})

function ProcodileLDB:UpdateText(enabled)
	if enabled then
		dataobj.text = "Enabled"
	else
		dataobj.text = "Disabled"
	end
end

function dataobj:OnEnter()
    GameTooltip:SetOwner(self, "ANCHOR_NONE")
    GameTooltip:SetPoint("TOPLEFT", self, "BOTTOMLEFT")
    GameTooltip:ClearLines()

    Procodile.PopulateTooltip()
    
    GameTooltip:AddLine(L["Hint: Ctrl-Click to reset."], 0, 1, 0)
    GameTooltip:AddLine(L["Shift-click to toggle tracking."], 0, 1, 0)
    GameTooltip:AddLine(L["Right-click to configure"], 0, 1, 0)
    
    GameTooltip:Show()
end

function dataobj:OnLeave()
    GameTooltip:Hide()
end

function dataobj:OnClick(button)
	if button == "LeftButton" and IsShiftKeyDown() then
		Procodile:Toggle()
	elseif button == "LeftButton" and IsControlKeyDown() then
		Procodile:Reset()
	elseif button == "RightButton" then
		Procodile:OpenOptions()
	end
end

